unit MasterUnit ;

interface

uses
  Windows, Messages, ShellAPI, SysUtils, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, ComCtrls, CommCtrl, Gauges,
  MMSystem, dsound ;

const
  MaxWave = 10240       ; //  ő哯Đ
  Max     = MaxWave - 1 ; //  ő哯Đ̍Ɨpϐi[`j
type
  TMasterForm = class(TForm)
    OpenDialog1    : TOpenDialog ;
    New            : TButton     ;
    MasterMute     : TButton     ;
    PanL           : TLabel      ;
    PanE           : TEdit       ;
    PanF           : TTrackBar   ;
    //  {[ZNV
    VolumeL        : TLabel      ;
    VolumeLP       : TPanel      ;
    VolumeP        : TPanel      ;
    VolumeWaveL    : TLabel      ;
    VolumeWaveE    : TEdit       ;
    VolumeWaveF    : TTrackBar   ;
    VolumeSpeakerL : TLabel      ;
    VolumeSpeakerE : TEdit       ;
    VolumeSpeakerF : TTrackBar   ;
    //  CRCU[ZNV
    EQL            : TLabel      ;
    EQLP           : TPanel      ;
    EQP            : TPanel      ;
    EQLoL          : TLabel      ;
    EQLoE          : TEdit       ;
    EQLoF          : TTrackBar   ;
    EQHiL          : TLabel      ;
    EQHiE          : TEdit       ;
    EQHiF          : TTrackBar   ;
    //  [^[ZNV
    MeterL         : TLabel      ;
    MeterLP        : TPanel      ;
    MaterP         : TPanel      ;
    MeterLL        : TLabel      ;
    MeterLE        : TEdit       ;
    MeterLG        : TGauge      ;
    MeterRL        : TLabel      ;
    MeterRE        : TEdit       ;
    MeterRG        : TGauge      ;
    MeterT         : TTimer      ;
    procedure FormCreate(Sender : TObject) ;
    procedure FormClose(Sender : TObject ; var Action : TCloseAction) ;
    procedure NewClick(Sender : TObject) ;
    procedure VolumeSpeakerFChange(Sender : TObject) ;
    procedure VolumeSpeakerEChange(Sender : TObject) ;
    procedure PanFChange(Sender : TObject) ;
    procedure PanEChange(Sender : TObject) ;
    procedure EQLoFChange(Sender : TObject) ;
    procedure EQLoEChange(Sender : TObject) ;
    procedure EQHiFChange(Sender : TObject) ;
    procedure EQHiEChange(Sender : TObject) ;
    procedure VolumeWaveFChange(Sender : TObject) ;
    procedure VolumeWaveEChange(Sender : TObject) ;
    procedure MasterMuteKeyDown(Sender : TObject ; var Key : Word ;
      Shift : TShiftState) ;
    procedure MasterMuteKeyUp(Sender : TObject ; var Key : Word ;
      Shift : TShiftState) ;
    procedure MasterMuteKeyPress(Sender : TObject ; var Key : Char) ;
    procedure MasterMuteMouseDown(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure MasterMuteMouseUp(Sender : TObject ; Button : TMouseButton ;
      Shift : TShiftState ; X, Y : Integer) ;
    procedure MeterTTimer(Sender : TObject) ;
  private
    { Private declarations }
    procedure MixerCallBack
      (var Msg : TMessage) ; Message MM_MIXM_CONTROL_CHANGE ;
    procedure MasterDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
    procedure ApplicationActivate(Sender : TObject) ;
    procedure ApplicationDeactivate(Sender : TObject) ;
  public
    { Public declarations }
  end ;

var
  MasterForm : TMasterForm                          ; //  }X^[Rg[
  DS         : IDirectSound                         ; //  _CNgTEhIuWFNg
  DS1stB     : IDirectSoundBuffer                   ; //  vC}obt@
  DS2ndB     : array[0.. Max] of IDirectSoundBuffer ; //  ZJ_obt@
  WF         : TWaveFormatEX                        ; //  WAVEtH[}bg\
  ModuleList : TList                                ; //  W[Xgi|C^j
  ModuleID   : Integer                              ; //  W[io[
  FPFN       : String                               ; //  t@Cl[itpXj
  FN         : String                               ; //  t@Cl[
  WaveSize   : DWORD                                ; //  WAVEt@CTCYiVKj
  WaveSizeM  : array [0.. Max] of DWORD             ; //  WAVEt@CTCYiʁj
  WaveTime   : DWORD                                ; //  WAVEv~ZRhiVKj
  WaveTimeM  : array [0.. Max] of DWORD             ; //  WAVEv~ZRhiʁj
  HM         : HMIXER                               ; //  ~LT[nh
  MCP        : TMixerCaps                           ; //  TMixerCaps\
  ML_D_S     : TMixerLine                           ; //  Xs[J[o̓C\
  ML_C_W     : TMixerLine                           ; //  WAVE̓C\
  MLC        : TMixerLineControls                   ; //  TMixerLineControls\
  MCL        : TMixerControl                        ; //  TMixerControl\
  MCD        : TMixerControlDetails                 ; //  TMixerControlDetails\
  PanLR      : array [0.. 1024] of DWORD            ; //  Xs[J[{[E
  PanLeft    : DWORD                                ; //  Xs[J[{[
  PanRight   : DWORD                                ; //  Xs[J[{[E
  PanPos     : Integer                              ; //  ݂̃p̈ʒu̒l
  VolPos     : DWORD                                ; //  Xs[J[{[ʒu
  PanMax     : DWORD                                ; //  ݂̃pW̃}bNXl
  Bass       : DWORD                                ; //  Xs[J[ቹ
  Treble     : DWORD                                ; //  Xs[J[
  VolumeWave : DWORD                                ; //  EF[u{[
  Mute       : Boolean                              ; //  ~[g
  MeterLR    : array [0.. 1024] of DWORD            ; //  [^[E̔z
  MeterLeft  : DWORD                                ; //  [^[
  MeterRight : DWORD                                ; //  [^[E
  MasterActivateFlag : DWORD                        ; //  ANeButO

  procedure LoadWave(var FPFN : String ; var ModuleBuf : Integer) ;

implementation

uses
  ModuleUnit ;

{$R *.DFM}

//y CjVCY z
procedure TMasterForm.FormCreate(Sender : TObject) ;
var
  TBS  : DWORD        ; //  gbNo[TBS_ENABLESELRANGEpϐ
  DSBD : DSBufferDesc ; //  _CNgTEhobt@\
  C    : Integer      ; //  JE^
begin
  //y ANeBu z
  Application.OnActivate := ApplicationActivate ;
  Application.OnDeactivate := ApplicationDeactivate ;
  //y hOhbvbZ[W z
  Application.OnMessage := MasterDropMsg ;
  DragAcceptFiles(MasterForm.Handle, True) ;
  //y gbNo[TBS_ENABLESELRANGE z
  TBS := GetWindowLong(VolumeWaveF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(VolumeWaveF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(VolumeSpeakerF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(VolumeSpeakerF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(PanF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(PanF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(EQLoF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(EQLoF.Handle, GWL_STYLE, TBS) ;
  TBS := GetWindowLong(EQHiF.Handle, GWL_STYLE) and (not TBS_ENABLESELRANGE) ;
  SetWindowLong(EQHiF.Handle, GWL_STYLE, TBS) ;
  //y ϐ z
  ModuleID  := 0      ; //  W[io[
  FPFN      := 'None' ; //  t@Cl[itpXj
  FN        := 'None' ; //  t@Cl[
{

 _CNgTEh 

}
  //y RXgN^ z
  DirectSoundCreate(Nil, DS, Nil) ;
  //y x z
  DS.SetCooperativeLevel(Handle, DSSCL_EXCLUSIVE) ;
  //y DSBUFFERDESC\ z
  Zeromemory(@DSBD, Sizeof(DSBufferDesc)) ;
  with DSBD do
    begin
      dwSize := Sizeof(DSBufferDesc) ;
      dwFlags :=
          DSBCAPS_PRIMARYBUFFER  //  vC}obt@
        + DSBCAPS_STATIC         //  X^eBbNobt@
        + DSBCAPS_CTRLFREQUENCY  //  sb`Rg[
        + DSBCAPS_CTRLPAN        //  p|bg
        + DSBCAPS_CTRLVOLUME     //  {[
        + DSBCAPS_GLOBALFOCUS    //  O[oobt@
        + DSBCAPS_STICKYFOCUS ;  //  XeBbL[obt@
    end ;
  //y vC}obt@ z
  DS.CreateSoundBuffer(@DSBD, DS1stB, nil) ;
  //y ZJ_obt@ z
  for C := 0 to Max do begin DS2ndB[C] := nil ; end ;
{

 I[fBI~LT[ 

}
  // foCX݂ȂΏI
  if mixerGetNumDevs = 0 then Exit ;
  //  ŏi ID=0 j̃foCX̏TMixerCaps\̂֊i[
  mixerGetDevCaps(0, @MCP, Sizeof(MCP)) ;
  //  ŏi ID=0 j̃foCXI[v
  mixerOpen(@HM, 0, Handle, Integer(Self), CALLBACK_WINDOW
                                         + MIXER_OBJECTF_MIXER) ;
{
fBXeBl[VCEXs[J[
}
  //  Xs[J[i ID=0 j̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
{[Rg[pRg[
}
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃{[Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃{[Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̃{[Rg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := ML_D_S.cChannels                     ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @PanLR                               ;
  end ;
  //  Xs[J[̃{[Rg[̌ݒl擾
  //  TMixerControlDetails\̂Ŏ󂯎
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  //  TMixerControlDetails\̂Ŏ󂯎
  //  Xs[J[̃{[Rg[
  //  LRꂼ̌ݒlAꂼ̕ϐɊi[
  if PanLR[0] = PanLR[1] then PanMax := PanLR[0] ;
  if PanLR[0] > PanLR[1] then PanMax := PanLR[0] ;
  if PanLR[0] < PanLR[1] then PanMax := PanLR[1] ;
  PanLeft  := PanLR[0] ;
  PanRight := PanLR[1] ;
  //  p̒lZoAgbNo[ƃGfBbgɔf
  //  p̒lrA傫Xs[J[{[
  //  gbNo[ƃGfBbgɔf
  if PanLeft = PanRight then                                         //  L=RȂ
    if PanLeft = 0 then
      begin
        VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;       //  ʒuɔf
        VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;       //  lɔf
      end else
      begin
        PanF.Position := 0 ;                                             //  ʒuɔf
        PanE.Text := IntToStr(0) ;                                       //  lɔf
        VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;       //  ʒuɔf
        VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;       //  lɔf
      end ;
  if PanLeft > PanRight then                                         //  L>RȂ
    begin
      if PanRight = 0 then                                             //  R=0Ȃ
        begin
          PanF.Position := -65535 ;                                      //  ʒuɔf
          PanE.Text := IntToStr(-65535) ;                                //  lɔf
          VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;     //  ʒuɔf
          VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;     //  lɔf
        end ;
      if PanRight <> 0 then                                            //  R<>0Ȃ
        begin
          PanF.Position :=
            (65535 - (((655350000 div PanLeft) * PanRight) div 10000))
                                                               * (- 1) ; //  ʒuɔf
          PanE.Text := IntToStr(PanF.Position) ;                         //  lɔf
          VolumeSpeakerF.Position := Integer(PanLeft) * -1 + 65535 ;     //  ʒuɔf
          VolumeSpeakerE.Text := IntToStr(Integer(PanLeft))        ;     //  lɔf
        end ;
    end ;
  if PanLeft < PanRight then                                         //  L<RȂ
    begin
      if PanLeft = 0 then                                              //  L=0Ȃ
        begin
          PanF.Position := 65535 ;                                       //  ʒuɔf
          PanE.Text := IntToStr(65535) ;                                 //  lɔf
          VolumeSpeakerF.Position := Integer(PanRight) * -1 + 65535 ;    //  ʒuɔf
          VolumeSpeakerE.Text := IntToStr(Integer(PanRight))        ;    //  lɔf
        end ;
      if PanLeft <> 0 then                                             //  L<>0Ȃ
        begin
          PanF.Position :=
            (65535 - (((655350000 div PanRight) * PanLeft) div 10000))
                                                               * (+ 1) ; //  ʒuɔf
          PanE.Text := IntToStr(PanF.Position) ;                         //  lɔf
          VolumeSpeakerF.Position := Integer(PanRight) * -1 + 65535 ;    //  ʒuɔf
          VolumeSpeakerE.Text := IntToStr(Integer(PanRight))        ;    //  lɔf
        end ;
    end ;
{
ቹRg[
}
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)    ;
    dwLineID      := ML_D_S.dwLineID               ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
    cControls     := ML_D_S.cControls              ;
    cbmxctrl      := Sizeof(TMixerControl)         ;
    pamxctrl      := @MCL                          ;
  end ;
  //  Xs[J[̒ቹRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̒ቹRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̒ቹRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Bass                                ;
  end ;
  //  Xs[J[̒ቹRg[̌ݒl擾
  //  TMixerControlDetails\̂Ŏ󂯎
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  //  TMixerControlDetails\̂Ŏ󂯎
  //  Xs[J[̒ቹRg[̌ݒl
  //  gbNo[ƃGfBbgɔf
  EQLoF.Position := Integer(Bass) * - 1 + 32768 ; //  ʒuɔf
  EQLoE.Text := IntToStr(Integer(Bass) - 32768) ; //  lɔf
{
Rg[
}
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̍Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̍Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̍Rg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Treble                              ;
  end ;
  //  Xs[J[̍Rg[̌ݒl擾
  //  TMixerControlDetails\̂Ŏ󂯎
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  //  TMixerControlDetails\̂Ŏ󂯎
  //  Xs[J[̍Rg[̌ݒl
  //  gbNo[ƃGfBbgɔf
  EQHiF.Position := Integer(Treble) * - 1 + 32768 ; //  ʒuɔf
  EQHiE.Text := IntToStr(Integer(Treble) - 32768) ; //  lɔf
{
RlNVCEEF[u
}
  //  EF[u̓̓C̏TMixerLine\̂Ɏw
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  //  EF[u̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
{[Rg[
}
  //  EF[u̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_C_W.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_C_W.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  EF[ũ{[Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  EF[ũ{[Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  EF[ũ{[Rg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @VolumeWave                       ;
  end ;
  //  EF[ũ{[Rg[̌ݒl擾
  //  TMixerControlDetails\̂Ŏ󂯎
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  //  TMixerControlDetails\̂Ŏ󂯎
  //  EF[ũ{[Rg[̌ݒl
  //  gbNo[ƃGfBbgɔf
  VolumeWaveF.Position := Integer(VolumeWave) * -1 + 65535 ; //  ʒuɔf
  VolumeWaveE.Text := IntToStr(Integer(VolumeWave))        ; //  lɔf
end ;

//y N[Y z
procedure TMasterForm.FormClose(Sender : TObject ; var Action : TCloseAction) ;
var
  C    : Integer      ; //  JE^
begin
{

 I[fBI~LT[ 

}
  mixerClose(HM) ; //  I[vI[fBI~LT[foCXN[Y
{

 _CNgTEh 

}
  //y ZJ_obt@ z
  for C := 0 to Max do
    begin
      if DS2ndB[C] <> nil then
        begin
          DS2ndB[C].Release ;
          DS2ndB[C] := nil ;
        end;
    end;
  //y vC}obt@ z
  if DS1stB <> nil then
    begin
      DS1stB.Release ;
      DS1stB := nil ;
    end;
  //y _CNgTEhIuWFNg z
  if DS <> nil then
    begin
      DS.Release ;
      DS := nil ;
    end ;
end ;

{

y [h[` z

  FPFN      : tpXt@Cl[
  ModuleBuf : W[io[

}
procedure LoadWave(var FPFN : String ; var ModuleBuf : Integer) ;
var
  F         : TFileStream          ; //  t@CXg[
  DSBD      : DSBufferDesc         ; //  _CNgTEhobt@\
  FCheck4B  : array[0.. 3] of Char ; //  RIFF,WAVE,data
  FCheck3B  : array[0.. 2] of Char ; //  fmt
  WaveBuf1  : Pointer              ; //  bN|C^P
  WaveBuf2  : Pointer              ; //  bN|C^Q
  WaveSize1 : DWORD                ; //  bNTCYP
  WaveSize2 : DWORD                ; //  bNTCYQ
begin
  F := TFileStream.Create(FPFN, fmOpenRead) ; //  t@CXg[
  //y DSBUFFERDESC\ z
  Zeromemory(@DSBD, Sizeof(DSBufferDesc)) ;
  with DSBD do
    begin
      dwSize := Sizeof(DSBufferDesc) ;
      dwFlags :=
          DSBCAPS_STATIC         //  X^eBbNobt@
        + DSBCAPS_CTRLFREQUENCY  //  sb`Rg[
        + DSBCAPS_CTRLPAN        //  p|bg
        + DSBCAPS_CTRLVOLUME     //  {[
        + DSBCAPS_GLOBALFOCUS    //  O[oobt@
        + DSBCAPS_STICKYFOCUS ;  //  XeBbL[obt@
      //y RIFF CHUNK z
      F.Position := 0 ;                      //  gbvɃZbg
      F.Read(FCheck4B, Sizeof(FCheck4B)) ;   //  SoCgǂݍ
      if String(FCheck4B) <> 'RIFF' then     //  RIFFH
        begin F.Free ; Exit ; end ;          //  Ⴄ̂ŏI
      F.Seek(4, 1) ;                         //  SoCg֐i
      F.Read(FCheck4B, Sizeof(FCheck4B)) ;   //  SoCgǂݍ
      if String(FCheck4B) <> 'WAVE' then     //  WAVEH
        begin F.Free ; Exit ; end ;          //  Ⴄ̂ŏI
      F.Read(FCheck3B, Sizeof(FCheck3B)) ;   //  RoCgǂݍ
      if String(FCheck3B) <> 'fmt' then      //  fmtH
        begin F.Free ; Exit ; end ;          //  Ⴄ̂ŏI
      F.Seek(5, 1) ;                         //  ToCg֐i
      F.Read(WF, 16) ;                       //  `Nf[^ǂݍ
      lpwfxFormat := @WF ;                   //  tH[}bgZbg
      F.Read(FCheck4B, Sizeof(FCheck4B)) ;   //  SoCgǂݍ
      if String(FCheck4B) <> 'data' then     //  dataH
        begin F.Free ; Exit ; end ;          //  Ⴄ̂ŏI
      F.Read(dwBufferBytes, Sizeof(DWORD)) ; //  WAVETCY擾
      F.Position := 0 ;                      //  gbvɃZbg
      F.Seek(40, 1) ;                        //  SOoCg֐i
      F.Read(WaveSize, Sizeof(DWORD)) ;      //  WAVETCY擾
    end;
  //y ZJ_obt@ z
  if DS2ndB[ModuleBuf] <> nil then           //  ̃W[݂Ȃ
    begin
      DS2ndB[ModuleBuf].Release ;            //  VK쐬̑Oɍ폜
      DS2ndB[ModuleBuf] := nil ;
    end;
  //y ZJ_obt@쐬 z
  DS.CreateSoundBuffer(@DSBD, DS2ndB[ModuleBuf], nil) ;
  //y bN z
  DS2ndB[ModuleBuf].Lock
    (0, DSBD.dwBufferBytes, WaveBuf1, @WaveSize1, WaveBuf2, @WaveSize2, 0) ;
  //y [h z
  F.Position := 44 ;
  F.Read(WaveBuf1^, WaveSize1) ;
  if WaveSize2 <> 0 then
    begin
      F.Read(WaveBuf2^, WaveSize2) ;
    end ;
  //y AbN z
  DS2ndB[ModuleBuf].Unlock
    (WaveBuf1, WaveSize1, WaveBuf2, WaveSize2) ;
  F.Free ;
end ;

//y VKW[쐬 z
procedure TMasterForm.NewClick(Sender : TObject) ;
begin
  if OpenDialog1.Execute then
    begin
      FPFN := OpenDialog1.FileName ;          //  t@Cl[擾itpXj
      FN := ExtractFileName(FPFN) ;           //  t@Cl[擾
      ModuleList.Add(TModuleForm.Create(Self)) ;        //  W[
      LoadWave(FPFN, ModuleID) ;              //  WAVEt@C[h
      WaveSizeM[ModuleID] := WaveSize ;       //  擾WAVETCYz
      WaveTimeM[ModuleID] :=
          WaveSizeM[ModuleID] div 1764 * 10 ; //  WAVE^C擾
      TModuleForm(ModuleList[ModuleID]).Caption := FN ; //  LvV\
      TModuleForm(ModuleList[ModuleID]).TimeE.Text :=
                        IntToStr(WaveTimeM[ModuleID]) ; //  WAVE^C\
      TModuleForm(ModuleList[ModuleID]).Show ;          //  W[\
      Inc(ModuleID) ;                         //  JE^CNgi{Pj
    end else
      Exit ;                                  //  t@CI[vLZ
end ;

//y fBXeBl[VCEXs[J[{[tF[_[ z
procedure TMasterForm.VolumeSpeakerFChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then  //  ANeBuȂ
    begin
      Exit ;                      //  Ȃ
    end ;
  if MasterActivateFlag = 1 then  //  ANeBuȂ
    begin
      VolumeSpeakerE.Text :=
        IntToStr(VolumeSpeakerF.Position * -1 + 65535) ; //  lɔf
      //  Xs[J[̃{[gbNo[擾l
      //  p̒l̑傫̃Rg[̔zɃZbg
      //  p̒lEΗ̃Rg[̔zɃZbg
      //  p̒lƑ傫̒l珬̒lZo
      //  Rg[̔zɃZbg
      VolPos := VolumeSpeakerF.Position * -1 + 65535 ;
      PanPos := PanF.Position ;
      if PanPos = 0 then
        begin
          PanLR[0] := VolPos ;
          PanLR[1] := VolPos ;
        end ;
      if PanPos < 0 then
        begin
          PanLR[0] := VolPos ;
          PanLR[1] := (VolPos div 2) * (65535 - PanPos * (- 1)) div 65535 * 2 ;
        end ;
      if PanPos > 0 then
        begin
          PanLR[0] := (VolPos div 2) * (65535 - PanPos) div 65535 * 2 ;
          PanLR[1] := VolPos ;
        end ;

      //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
      with ML_D_S do begin
        cbStruct        := Sizeof(TMixerLine)                   ;
        dwDestination   := 0                                    ;
        dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
      end ;
      //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
      mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                                  + MIXER_OBJECTF_HMIXER) ;
      //  Xs[J[o̓C̃Rg[̏
      //  TMixerLineControls\̂Ɏw
      with MLC do begin
        cbStruct      := Sizeof(TMixerLineControls)      ;
        dwLineID      := ML_D_S.dwLineID                 ;
        dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
        cControls     := ML_D_S.cControls                ;
        cbmxctrl      := Sizeof(TMixerControl)           ;
        pamxctrl      := @MCL                            ;
      end ;
      //  Xs[J[̃{[Rg[̏
      //  TMixerControl\̂Ɏw
      with MCL do begin
        cbStruct   := Sizeof(TMixerControl)         ;
        fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
      end ;
      //  TMixerLineControls\̂TMixerControl\̂
      //  Xs[J[̃{[Rg[̏Q
      mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                   + MIXER_OBJECTF_HMIXER) ;
      //  Xs[J[̃{[Rg[̏
      //  TMixerControlDetails\̂Ɏw
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := ML_D_S.cChannels                     ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @PanLR                               ;
      end ;
      //  Xs[J[̃{[Rg[̃o[l
      //  TMixerControlDetails\̂ɃZbg
      mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_SETCONTROLDETAILSF_VALUE) ;
      //  TMixerControlDetails\̂Ŏ󂯎
      //  Xs[J[̃{[Rg[
      //  LRꂼ̌ݒlAꂼ̕ϐɊi[
      if PanLR[0] = PanLR[1] then PanMax := PanLR[0] ;
      if PanLR[0] > PanLR[1] then PanMax := PanLR[0] ;
      if PanLR[0] < PanLR[1] then PanMax := PanLR[1] ;
      PanLeft  := PanLR[0] ;
      PanRight := PanLR[1] ;
      PanF.Position := PanPos ;
    end ; //u ANeBuȂ ` if then begin vɑ΂end
end ;

//y fBXeBl[VCEXs[J[{[GfBbg z
procedure TMasterForm.VolumeSpeakerEChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then  //  ANeBuȂ
    begin
      Exit ;                      //  Ȃ
    end ;
  if MasterActivateFlag = 1 then  //  ANeBuȂ
    begin
      try StrToInt(VolumeSpeakerE.Text) ; except Exit ; end ; //  LH
      if StrToInt(VolumeSpeakerE.Text) > 65535 then
        VolumeSpeakerE.Text := '65535' ;                      //  ȏ
      if StrToInt(VolumeSpeakerE.Text) < 0 then
        VolumeSpeakerE.Text := '0' ;                          //  ȉ
          begin
            VolumeSpeakerF.Position
              := StrToInt(VolumeSpeakerE.Text) * -1 + 65535 ; //  ʒuɔf
            //  Xs[J[̃{[GfBbg擾l
            //  p̒l̑傫̃Rg[̔zɃZbg
            //  p̒lEΗ̃Rg[̔zɃZbg
            //  p̒lƑ傫̒l珬̒lZo
            //  Rg[̔zɃZbg
            PanPos := PanF.Position ;
            if PanPos = 0 then
              begin
                PanLR[0] := StrToInt(VolumeSpeakerE.Text) ;
                PanLR[1] := StrToInt(VolumeSpeakerE.Text) ;
              end ;
            if PanPos < 0 then
              begin
                PanLR[0] := StrToInt(VolumeSpeakerE.Text) ;
                PanLR[1] := PanLR[0] * 10000 div 65535
                              * (65535 - PanPos * -1) div 10000 ;
              end ;
            if PanPos > 0 then
              begin
                PanLR[1] := StrToInt(VolumeSpeakerE.Text) ;
                PanLR[0] := PanLR[1] * 10000 div 65535
                              * (65535 - PanPos) div 10000 ;
              end ;
            //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
            with ML_D_S do begin
              cbStruct        := Sizeof(TMixerLine)                   ;
              dwDestination   := 0                                    ;
              dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
            end ;
            //  Xs[J[o̓C̏擾
            //  TMixerLine\̂Ŏ󂯎
            mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                                        + MIXER_OBJECTF_HMIXER) ;
            //  Xs[J[o̓C̃Rg[̏
            //  TMixerLineControls\̂Ɏw
            with MLC do begin
              cbStruct      := Sizeof(TMixerLineControls)      ;
              dwLineID      := ML_D_S.dwLineID                 ;
              dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
              cControls     := ML_D_S.cControls                ;
              cbmxctrl      := Sizeof(TMixerControl)           ;
              pamxctrl      := @MCL                            ;
            end ;
            //  Xs[J[̃{[Rg[̏
            //  TMixerControl\̂Ɏw
            with MCL do begin
              cbStruct   := Sizeof(TMixerControl)         ;
              fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
            end ;
            //  TMixerLineControls\̂TMixerControl\̂
            //  Xs[J[̃{[Rg[̏Q
            mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                         + MIXER_OBJECTF_HMIXER) ;
            //  Xs[J[̃{[Rg[̏
            //  TMixerControlDetails\̂Ɏw
            with MCD do begin
              cbStruct       := Sizeof(TMixerControlDetails)         ;
              dwControlID    := MCL.dwControlID                      ;
              cChannels      := ML_D_S.cChannels                     ;
              cMultipleItems := 0                                    ;
              cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
              paDetails      := @PanLR                               ;
            end ;
            //  Xs[J[̃{[Rg[̃o[l
            //  TMixerControlDetails\̂ɃZbg
            mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                           + MIXER_SETCONTROLDETAILSF_VALUE) ;
            //  TMixerControlDetails\̂Ŏ󂯎
            //  Xs[J[̃{[Rg[
            //  LRꂼ̌ݒlAꂼ̕ϐɊi[
            if PanLR[0] = PanLR[1] then PanMax := PanLR[0] ;
            if PanLR[0] > PanLR[1] then PanMax := PanLR[0] ;
            if PanLR[0] < PanLR[1] then PanMax := PanLR[1] ;
            PanLeft  := PanLR[0] ;
            PanRight := PanLR[1] ;
          end ;
    end ; //u ANeBuȂ ` if then begin vɑ΂end
end ;

//y fBXeBl[VCEXs[J[ptF[_[ z
procedure TMasterForm.PanFChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then  //  ANeBuȂ
    begin
      Exit ;                      //  Ȃ
    end ;
  if MasterActivateFlag = 1 then  //  ANeBuȂ
    begin
      PanE.Text := IntToStr(PanF.Position) ; //  lɔf
      //  ƉE
      if PanF.Position = 0 then
        begin
          if PanLR[0] = PanLR[1] then Exit ;
          if PanLR[0] > PanLR[1] then PanLR[1] := PanLR[0] ;
          if PanLR[0] < PanLR[1] then PanLR[0] := PanLR[1] ;
        end ;
      //  ̕傫
      if PanF.Position < 0 then
        begin
          PanLR[0] := PanMax ;
          PanLR[1] := PanLR[0] * 10000 div 65535
                        * (65535 - PanF.Position * -1) div 10000 ;
        end ;
      //  E̕傫
      if PanF.Position > 0 then
        begin
          PanLR[1] := PanMax ;
          PanLR[0] := PanLR[1] * 10000 div 65535
                        * (65535 - PanF.Position) div 10000 ;
        end ;
      //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
      with ML_D_S do begin
        cbStruct        := Sizeof(TMixerLine)                   ;
        dwDestination   := 0                                    ;
        dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
      end ;
      //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
      mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                                  + MIXER_OBJECTF_HMIXER) ;
      //  Xs[J[o̓C̃Rg[̏
      //  TMixerLineControls\̂Ɏw
      with MLC do begin
        cbStruct      := Sizeof(TMixerLineControls)      ;
        dwLineID      := ML_D_S.dwLineID                 ;
        dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
        cControls     := ML_D_S.cControls                ;
        cbmxctrl      := Sizeof(TMixerControl)           ;
        pamxctrl      := @MCL                            ;
      end ;
      //  Xs[J[̃{[Rg[̏
      //  TMixerControl\̂Ɏw
      with MCL do begin
        cbStruct   := Sizeof(TMixerControl)         ;
        fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
      end ;
      //  TMixerLineControls\̂TMixerControl\̂
      //  Xs[J[̃{[Rg[̏Q
      mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                   + MIXER_OBJECTF_HMIXER) ;
      //  Xs[J[̃{[Rg[̏
      //  TMixerControlDetails\̂Ɏw
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := ML_D_S.cChannels                     ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @PanLR                               ;
      end ;
      //  Xs[J[̃{[Rg[̃o[l
      //  TMixerControlDetails\̂ɃZbg
      mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_SETCONTROLDETAILSF_VALUE) ;
      //  TMixerControlDetails\̂Ŏ󂯎
      //  Xs[J[̃{[Rg[
      //  LRꂼ̌ݒlAꂼ̕ϐɊi[
      PanLeft  := PanLR[0] ;
      PanRight := PanLR[1] ;
      PanPos := PanF.Position ;
    end ; //u ANeBuȂ ` if then begin vɑ΂end
end ;

//y fBXeBl[VCEXs[J[pGfBbg z
procedure TMasterForm.PanEChange(Sender : TObject) ;
begin
  if MasterActivateFlag = 0 then  //  ANeBuȂ
    begin
      Exit ;                      //  Ȃ
    end ;
  if MasterActivateFlag = 1 then  //  ANeBuȂ
    begin
      try StrToInt(PanE.Text) ; except Exit ; end ; //  LH
      if StrToInt(PanE.Text) > 65535 then
        PanE.Text := '65535' ;                      //  ȏ
      if StrToInt(PanE.Text) < -65535 then
        PanE.Text := '-65535' ;                     //  ȉ
      PanF.Position := StrToInt(PanE.Text) ;        //  ʒuɔf
    end ; //u ANeBuȂ ` if then begin vɑ΂end
end ;

//y fBXeBl[VCEXs[J[ቹtF[_[ z
procedure TMasterForm.EQLoFChange(Sender : TObject) ;
begin
  EQLoE.Text := IntToStr(EQLoF.Position * -1) ;           // lɔf
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)    ;
    dwLineID      := ML_D_S.dwLineID               ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
    cControls     := ML_D_S.cControls              ;
    cbmxctrl      := Sizeof(TMixerControl)         ;
    pamxctrl      := @MCL                          ;
  end ;
  //  Xs[J[̒ቹRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̒ቹRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  ቹgbNo[擾lቹRg[ɃZbg
  Bass := EQLoF.Position * -1 + 32768 ;
  //  Xs[J[̒ቹRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Bass                                ;
  end ;
  //  Xs[J[̒ቹRg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end ;

//y fBXeBl[VCEXs[J[ቹGfBbg z
procedure TMasterForm.EQLoEChange(Sender : TObject) ;
begin
  try StrToInt(EQLoE.Text) ; except Exit ; end ;        //  LH
  if StrToInt(EQLoE.Text) > 32767 then
    EQLoE.Text := '32767' ;                             //  ȏ
  if StrToInt(EQLoE.Text) < -32768 then
    EQLoE.Text := '-32768' ;                            //  ȉ
      begin
        EQLoF.Position := StrToInt(EQLoE.Text) * -1 ;   //  ʒuɔf
        //  Xs[J[o̓C̃Rg[̏
        //  TMixerLineControls\̂Ɏw
        with MLC do begin
          cbStruct      := Sizeof(TMixerLineControls)    ;
          dwLineID      := ML_D_S.dwLineID               ;
          dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
          cControls     := ML_D_S.cControls              ;
          cbmxctrl      := Sizeof(TMixerControl)         ;
          pamxctrl      := @MCL                          ;
        end ;
        //  Xs[J[̒ቹRg[̏
        //  TMixerControl\̂Ɏw
        with MCL do begin
          cbStruct   := Sizeof(TMixerControl)         ;
          fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
        end ;
        //  TMixerLineControls\̂TMixerControl\̂
        //  Xs[J[̒ቹRg[̏Q
        mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                     + MIXER_OBJECTF_HMIXER) ;
        //  ቹGfBbg擾lቹRg[ɃZbg
        Bass := StrToInt(EQLoE.Text) + 32768 ;
        //  Xs[J[̒ቹRg[̏
        //  TMixerControlDetails\̂Ɏw
        with MCD do begin
          cbStruct       := Sizeof(TMixerControlDetails)         ;
          dwControlID    := MCL.dwControlID                      ;
          cChannels      := 1                                    ;
          cMultipleItems := 0                                    ;
          cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
          paDetails      := @Bass                                ;
        end ;
        //  Xs[J[̒ቹRg[̃o[l
        //  TMixerControlDetails\̂ɃZbg
        mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                       + MIXER_SETCONTROLDETAILSF_VALUE) ;
      end ;
end ;

//y fBXeBl[VCEXs[J[tF[_[ z
procedure TMasterForm.EQHiFChange(Sender : TObject) ;
begin
  EQHiE.Text := IntToStr(EQHiF.Position * -1) ;             //  lɔf
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̍Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̍Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  gbNo[擾lቹRg[ɃZbg
  Treble := EQHiF.Position * -1 + 32768 ;
  //  Xs[J[̍Rg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @Treble                              ;
  end ;
  //  Xs[J[̍Rg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end ;

//y fBXeBl[VCEXs[J[GfBbg z
procedure TMasterForm.EQHiEChange(Sender : TObject) ;
begin
  try StrToInt(EQHiE.Text) ; except Exit ; end ;        //  LH
  if StrToInt(EQHiE.Text) > 32767 then
    EQHiE.Text := '32767' ;                             //  ȏ
  if StrToInt(EQHiE.Text) < -32768 then
    EQHiE.Text := '-32768' ;                            //  ȉ
      begin
        EQHiF.Position := StrToInt(EQHiE.Text) * -1 ;   //  ʒuɔf
        //  Xs[J[o̓C̃Rg[̏
        //  TMixerLineControls\̂Ɏw
        with MLC do begin
          cbStruct      := Sizeof(TMixerLineControls)      ;
          dwLineID      := ML_D_S.dwLineID                 ;
          dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
          cControls     := ML_D_S.cControls                ;
          cbmxctrl      := Sizeof(TMixerControl)           ;
          pamxctrl      := @MCL                            ;
        end ;
        //  Xs[J[̍Rg[̏
        //  TMixerControl\̂Ɏw
        with MCL do begin
          cbStruct   := Sizeof(TMixerControl)         ;
          fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
        end ;
        //  TMixerLineControls\̂TMixerControl\̂
        //  Xs[J[̍Rg[̏Q
        mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                     + MIXER_OBJECTF_HMIXER) ;
        //  GfBbg擾lቹRg[ɃZbg
        Treble := StrToInt(EQHiE.Text) + 32768 ;
        //  Xs[J[̍Rg[̏
        //  TMixerControlDetails\̂Ɏw
        with MCD do begin
          cbStruct       := Sizeof(TMixerControlDetails)         ;
          dwControlID    := MCL.dwControlID                      ;
          cChannels      := 1                                    ;
          cMultipleItems := 0                                    ;
          cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
          paDetails      := @Treble                              ;
        end ;
        //  Xs[J[̍Rg[̃o[l
        //  TMixerControlDetails\̂ɃZbg
        mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                       + MIXER_SETCONTROLDETAILSF_VALUE) ;
      end ;
end ;

//y RlNVCEEF[u{[tF[_[ z
procedure TMasterForm.VolumeWaveFChange(Sender : TObject) ;
begin
  VolumeWaveE.Text := IntToStr(VolumeWaveF.Position * -1 + 65535) ; //  lɔf
  //  EF[u̓̓C̏TMixerLine\̂Ɏw
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  //  EF[u̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  //  EF[u̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_C_W.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_C_W.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  EF[ũ{[Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  EF[ũ{[Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  EF[u{[gbNo[擾l
  //  EF[u{[Rg[ɃZbg
  VolumeWave := VolumeWaveF.Position * -1 + 65535 ;
  //  EF[ũ{[Rg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @VolumeWave                       ;
  end ;
  //  EF[ũ{[Rg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end ;

//y RlNVCEEF[u{[GfBbg z
procedure TMasterForm.VolumeWaveEChange(Sender : TObject) ;
begin
  try StrToInt(VolumeWaveE.Text) ; except Exit ; end ; //  LH
  if StrToInt(VolumeWaveE.Text) > 65535 then
    VolumeWaveE.Text := '65535' ;                      //  ȏ
  if StrToInt(VolumeWaveE.Text) < 0 then
    VolumeWaveE.Text := '0' ;                          //  ȉ
      begin
        VolumeWaveF.Position
          := StrToInt(VolumeWaveE.Text) * -1 + 65535 ; //  ʒuɔf
        //  EF[u̓̓C̏TMixerLine\̂Ɏw
        with ML_C_W do begin
          cbStruct        := Sizeof(TMixerLine)                   ;
          dwDestination   := 0                                    ;
          dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
        end ;
        //  EF[u̓C̏擾
        //  TMixerLine\̂Ŏ󂯎
        mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                                    + MIXER_OBJECTF_HMIXER) ;
        //  EF[u̓C̃Rg[̏
        //  TMixerLineControls\̂Ɏw
        with MLC do begin
          cbStruct      := Sizeof(TMixerLineControls)      ;
          dwLineID      := ML_C_W.dwLineID                 ;
          dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
          cControls     := ML_C_W.cControls                ;
          cbmxctrl      := Sizeof(TMixerControl)           ;
          pamxctrl      := @MCL                            ;
        end ;
        //  EF[ũ{[Rg[̏
        //  TMixerControl\̂Ɏw
        with MCL do begin
          cbStruct   := Sizeof(TMixerControl)         ;
          fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
        end ;
        //  TMixerLineControls\̂TMixerControl\̂
        //  EF[ũ{[Rg[̏Q
        mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                                     + MIXER_OBJECTF_HMIXER) ;
        //  EF[u{[GfBbg擾l
        //  EF[u{[Rg[ɃZbg
        VolumeWave := StrToInt(VolumeWaveE.Text) ;
        //  EF[ũ{[Rg[̏
        //  TMixerControlDetails\̂Ɏw
        with MCD do begin
          cbStruct       := Sizeof(TMixerControlDetails)         ;
          dwControlID    := MCL.dwControlID                      ;
          cChannels      := 1                                    ;
          cMultipleItems := 0                                    ;
          cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
          paDetails      := @VolumeWave                       ;
        end ;
        //  EF[ũ{[Rg[̃o[l
        //  TMixerControlDetails\̂ɃZbg
        mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                       + MIXER_SETCONTROLDETAILSF_VALUE) ;
      end ;
end ;

//y fBXeBl[VCEXs[J[~[gEIt z
procedure TMasterForm.MasterMuteKeyDown(Sender : TObject ; var Key : Word ;
  Shift : TShiftState) ;
begin
  if key = Word(VK_SPACE) then Mute := False ;
  //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃~[gRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃~[gRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̃~[gRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  //  Xs[J[̃~[gRg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//y fBXeBl[VCEXs[J[~[gEI z
procedure TMasterForm.MasterMuteKeyUp(Sender : TObject ; var Key : Word ;
  Shift : TShiftState) ;
begin
  if key = Word(VK_SPACE) then Mute := True ;
  //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃~[gRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃~[gRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̃~[gRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  //  Xs[J[̃~[gRg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//y fBXeBl[VCEXs[J[~[gEIt z
procedure TMasterForm.MasterMuteKeyPress(Sender : TObject ; var Key : Char) ;
begin
  if key <> Char(VK_SPACE) then Mute := False ;
  //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃~[gRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃~[gRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̃~[gRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  //  Xs[J[̃~[gRg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//y fBXeBl[VCEXs[J[~[gEIt z
procedure TMasterForm.MasterMuteMouseDown(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  Mute := False ;
  //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃~[gRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃~[gRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̃~[gRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  //  Xs[J[̃~[gRg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//y fBXeBl[VCEXs[J[~[gEI z
procedure TMasterForm.MasterMuteMouseUp(Sender : TObject ;
  Button : TMouseButton ; Shift : TShiftState ; X, Y : Integer) ;
begin
  Mute := True ;
  //  Xs[J[̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_MUTE   ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃~[gRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃~[gRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  Xs[J[̃~[gRg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := 1                                    ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsBoolean)  ;
    paDetails      := @Mute                                ;
  end ;
  //  Xs[J[̃~[gRg[̃o[l
  //  TMixerControlDetails\̂ɃZbg
  mixerSetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_SETCONTROLDETAILSF_VALUE) ;
end;

//y RlNVCEEF[u[^[GfBbgE^C}[ z
procedure TMasterForm.MeterTTimer(Sender : TObject) ;
begin
{
RlNVCEEF[u
}
  //  EF[u̓̓C̏TMixerLine\̂Ɏw
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  //  EF[u̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
[^[Rg[
}
 //  EF[u̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)         ;
    dwLineID      := ML_C_W.dwLineID                    ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_PEAKMETER ;
    cControls     := ML_C_W.cControls                   ;
    cbmxctrl      := Sizeof(TMixerControl)              ;
    pamxctrl      := @MCL                               ;
  end ;
  //  EF[ũ[^[Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  EF[ũ[^[Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  EF[ũ[^[Rg[̏TMixerControlDetails\̂Ɏw
  with MCD do begin
    cbStruct       := Sizeof(TMixerControlDetails)         ;
    dwControlID    := MCL.dwControlID                      ;
    cChannels      := ML_C_W.cChannels                     ;
    cMultipleItems := 0                                    ;
    cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
    paDetails      := @MeterLR                             ;
  end ;
  //  EF[ũ[^[Rg[̌ݒl擾
  //  TMixerControlDetails\̂Ŏ󂯎
  mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
  //  TMixerControlDetails\̂Ŏ󂯎
  //  EF[ũ[^[Rg[̌ݒl
  //  GfBbgɔf
  MeterLeft  := MeterLR[0] ;
  MeterRight := MeterLR[1] ;
  MeterLeft  := Abs(MeterLeft)  ;
  MeterRight := Abs(MeterRight) ;
  MeterLG.Progress := MeterLeft ;
  MeterRG.Progress := MeterRight ;
  MeterLE.Text := IntToStr(MeterLeft) ;
  MeterRE.Text := IntToStr(MeterRight) ;

end ;

{

y R[obNbZ[WM z

}
procedure TMasterForm.MixerCallBack(var Msg : TMessage) ;
begin
  if MasterActivateFlag = 1 then //  ANeBuȂ
    begin
      Exit ;                     //  Ȃ
    end ;
  if MasterActivateFlag = 0 then //  ANeBuȂ
    begin
      case Msg.Msg of
        MM_MIXM_LINE_CHANGE :
          //  ̂߂ɁBƂ肠ȂB
          Exit ;
        MM_MIXM_CONTROL_CHANGE :
          begin
//**********************************************************************
{
fBXeBl[VCEXs[J[
}
  //  Xs[J[i ID=0 j̏o̓C̏TMixerLine\̂Ɏw
  with ML_D_S do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;
  end ;
  //  Xs[J[o̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_D_S, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
{[Rg[pRg[
}
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̃{[Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̃{[Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  MbZ[WXs[J[̃{[Rg[ł
  if Msg.lParam = MCL.dwControlID then
    begin
      //  Xs[J[̃{[Rg[̏
      //  TMixerControlDetails\̂Ɏw
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := ML_D_S.cChannels                     ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @PanLR                               ;
      end ;
      //  Xs[J[̃{[Rg[̌ݒl擾
      //  TMixerControlDetails\̂Ŏ󂯎
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                 + MIXER_GETCONTROLDETAILSF_VALUE) ;
      PanLeft  := PanLR[0] ;
      PanRight := PanLR[1] ;
      if PanLeft = PanRight then                              //  L=RȂ
        begin
          if PanLeft = 0 then                                   //  L=RȂ
            begin
              VolumeSpeakerF.Position :=
              Integer(PanLeft) * -1 + 65535 ;                     //  ʒuɔf
              VolumeSpeakerE.Text := IntToStr(Integer(PanLeft)) ; //  lɔf
            end ;
          if PanLeft <> 0 then                                  //  L=RȂ
            begin
              VolumeSpeakerF.Position :=
              Integer(PanLeft) * -1 + 65535 ;                     //  ʒuɔf
              VolumeSpeakerE.Text := IntToStr(Integer(PanLeft)) ; //  lɔf
              PanF.Position := 0 ;                                //  ʒuɔf
              PanE.Text := IntToStr(0) ;                          //  lɔf
            end ;
        end ;
      if PanLeft > PanRight then                              //  L>RȂ
        begin
          VolumeSpeakerF.Position :=
          Integer(PanLeft) * -1 + 65535 ;                       //  ʒuɔf
          VolumeSpeakerE.Text := IntToStr(Integer(PanLeft)) ;   //  lɔf
          PanF.Position :=
            (65535 - (((655350000 div PanLeft)
                              * PanRight) div 10000)) * (- 1) ; //  ʒuɔf
          PanE.Text := IntToStr(PanF.Position) ;                //  lɔf
        end ;
      if PanLeft < PanRight then                              //  L>RȂ
        begin
          VolumeSpeakerF.Position :=
          Integer(PanRight) * -1 + 65535 ;                      //  ʒuɔf
          VolumeSpeakerE.Text := IntToStr(Integer(PanRight)) ;  //  lɔf
          PanF.Position :=
            (65535 - (((655350000 div PanRight)
                               * PanLeft) div 10000)) * (+ 1) ; //  ʒuɔf
          PanE.Text := IntToStr(PanF.Position) ;                //  lɔf
        end ;
    end ; //  MbZ[Ẃu if then begin vɑ΂end

{
ቹRg[
}
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)    ;
    dwLineID      := ML_D_S.dwLineID               ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_BASS ;
    cControls     := ML_D_S.cControls              ;
    cbmxctrl      := Sizeof(TMixerControl)         ;
    pamxctrl      := @MCL                          ;
  end ;
  //  Xs[J[̒ቹRg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̒ቹRg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  MbZ[WXs[J[̒ቹRg[ł
  if Msg.lParam = MCL.dwControlID then
    begin
      //  Xs[J[̒ቹRg[̏
      //  TMixerControlDetails\̂Ɏw
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := 1                                    ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @Bass                                ;
      end ;
      //  Xs[J[̒ቹRg[̌ݒl擾
      //  TMixerControlDetails\̂Ŏ󂯎
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_GETCONTROLDETAILSF_VALUE) ;
      //  TMixerControlDetails\̂Ŏ󂯎
      //  Xs[J[̒ቹRg[̌ݒl
      //  gbNo[ƃGfBbgɔf
      EQLoF.Position := Integer(Bass) * - 1 + 32768 ; //  ʒuɔf
      EQLoE.Text := IntToStr(Integer(Bass) - 32768) ; //  lɔf
    end ; //  MbZ[Ẃu if then begin vɑ΂end

{
Rg[
}
  //  Xs[J[o̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_D_S.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_TREBLE ;
    cControls     := ML_D_S.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  Xs[J[̍Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  Xs[J[̍Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  MbZ[WXs[J[̍Rg[ł
  if Msg.lParam = MCL.dwControlID then
    begin
      //  Xs[J[̍Rg[̏
      //  TMixerControlDetails\̂Ɏw
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := 1                                    ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @Treble                              ;
      end ;
      //  Xs[J[̍Rg[̌ݒl擾
      //  TMixerControlDetails\̂Ŏ󂯎
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_GETCONTROLDETAILSF_VALUE) ;
      //  TMixerControlDetails\̂Ŏ󂯎
      //  Xs[J[̍Rg[̌ݒl
      //  gbNo[ƃGfBbgɔf
      EQHiF.Position := Integer(Treble) * - 1 + 32768 ; //  ʒuɔf
      EQHiE.Text := IntToStr(Integer(Treble) - 32768) ; //  lɔf
    end ; //  MbZ[Ẃu if then begin vɑ΂end

{
RlNVCEEF[u
}
  //  EF[u̓̓C̏TMixerLine\̂Ɏw
  with ML_C_W do begin
    cbStruct        := Sizeof(TMixerLine)                   ;
    dwDestination   := 0                                    ;
    dwComponentType := MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  ;
  end ;
  //  EF[u̓C̏擾ATMixerLine\̂Ŏ󂯎
  mixerGetLineInfo(HM, @ML_C_W, MIXER_GETLINEINFOF_COMPONENTTYPE
                              + MIXER_OBJECTF_HMIXER) ;
{
{[Rg[
}
  //  EF[u̓C̃Rg[̏TMixerLineControls\̂Ɏw
  with MLC do begin
    cbStruct      := Sizeof(TMixerLineControls)      ;
    dwLineID      := ML_C_W.dwLineID                 ;
    dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
    cControls     := ML_C_W.cControls                ;
    cbmxctrl      := Sizeof(TMixerControl)           ;
    pamxctrl      := @MCL                            ;
  end ;
  //  EF[ũ{[Rg[̏TMixerControl\̂Ɏw
  with MCL do begin
    cbStruct   := Sizeof(TMixerControl)         ;
    fdwControl := MIXERCONTROL_CONTROLF_UNIFORM ;
  end ;
  //  TMixerLineControls\̂TMixerControl\̂
  //  EF[ũ{[Rg[̏Q
  mixerGetLineControls(HM, @MLC, MIXER_GETLINECONTROLSF_ONEBYTYPE
                               + MIXER_OBJECTF_HMIXER) ;
  //  MbZ[WEF[ũ{[Rg[ł
  if Msg.lParam = MCL.dwControlID then
    begin
      //  EF[ũ{[Rg[̏
      //  TMixerControlDetails\̂Ɏw
      with MCD do begin
        cbStruct       := Sizeof(TMixerControlDetails)         ;
        dwControlID    := MCL.dwControlID                      ;
        cChannels      := 1                                    ;
        cMultipleItems := 0                                    ;
        cbDetails      := Sizeof(TMixerControlDetailsUnsigned) ;
        paDetails      := @VolumeWave                       ;
      end ;
      //  EF[ũ{[Rg[̌ݒl擾
      //  TMixerControlDetails\̂Ŏ󂯎
      mixerGetControlDetails(HM, @MCD, MIXER_OBJECTF_HMIXER
                                     + MIXER_GETCONTROLDETAILSF_VALUE) ;
      //  TMixerControlDetails\̂Ŏ󂯎
      //  EF[ũ{[Rg[̌ݒl
      //  gbNo[ƃGfBbgɔf
      VolumeWaveF.Position := Integer(VolumeWave) * -1 + 65535 ; //  ʒuɔf
      VolumeWaveE.Text := IntToStr(Integer(VolumeWave))        ; //  lɔf
    end ; //  MbZ[Ẃu if then begin vɑ΂end
//**********************************************************************
          end ; //  MbZ[Ẃu case of MM_MIXM_CONTROL_CHANGE : begin v
                //  ɑ΂end
      end ; //  MbZ[Ẃu case of vɑ΂end
    end ; //u ANeBuȂ ` if then begin vɑ΂end
end ;

//y hOhbv z
procedure TMasterForm.MasterDropMsg(var Msg : TMsg ; var Handled : Boolean) ;
const
  DropBuf = 255 ;
var
  DropFN : string ;
  FN     : string ;
begin
  if Msg.Message = WM_DROPFILES then
    begin
      SetLength(DropFN, DropBuf) ;
      DragQueryFile(Msg.wParam, 0, PChar(DropFN), DropBuf) ;
      ModuleList.Add(TModuleForm.Create(Self)) ;        //  W[
      LoadWave(DropFN, ModuleID) ;            //  WAVEt@C[h
      FN := ExtractFileName(DropFN) ;         //  t@Cl[擾
      WaveSizeM[ModuleID] := WaveSize ;       //  擾WAVETCYz
      WaveTimeM[ModuleID] :=
          WaveSizeM[ModuleID] div 1764 * 10 ; //  WAVE^C擾
      TModuleForm(ModuleList[ModuleID]).Caption := FN ; //  LvV\
      TModuleForm(ModuleList[ModuleID]).TimeE.Text :=
                                        IntToStr(WaveTimeM[ModuleID]) ;
      TModuleForm(ModuleList[ModuleID]).Show ;          //  W[\
      Inc(ModuleID) ;                         //  JE^CNgi{Pj
      DragFinish(Msg.wParam) ;
      Handled := True ;
    end ;
end ;

//y ANeBu z
procedure TMasterForm.ApplicationDeactivate(Sender : TObject) ;
begin
  MasterActivateFlag := 0 ;
end;

//y ANeBu z
procedure TMasterForm.ApplicationActivate(Sender : TObject) ;
begin
  MasterActivateFlag := 1 ;
end;

initialization
  ModuleList := TList.Create;

finalization
  ModuleList.Free;

end.

